#include "castice.h"
#include <cstdlib>
#include <ctime>
#include <cmath>

#define NA_STUPNE (M_PI/180.0)

///implicitni konstruktor struktury Nastaveni
Nastaveni::Nastaveni()
{
	x = y = uhel = 0;
	MAX_ZIVOT				=	10;
	MIN_ZIVOT				=	5;
	MAX_RYCHLOST		=	10;
	MIN_RYCHLOST		=	1;
	MAX_ZRYCHLENI		=	10;
	MIN_ZRYCHLENI		=	1;

	pocatecni.r = rand() % 255 + 1;
	pocatecni.g = rand() % 255 + 1;
	pocatecni.b = rand() % 255 + 1;

	koncova.r = rand() % 255 + 1;
	koncova.g = rand() % 255 + 1;
	koncova.b = rand() % 255 + 1;
}

///konstruktor pro urceni pocatecni a konecne barvy castice
Castice::Castice(Nastaveni &init)
{
	zije = true;
	x = init.x;
	y = init.y;
	krokX = cos(NA_STUPNE * init.uhel);
	krokY = sin(NA_STUPNE * init.uhel);

	delka_zivota = rand() % init.MAX_ZIVOT + init.MIN_ZIVOT;
	rychlost = rand() % init.MAX_RYCHLOST + init.MIN_RYCHLOST;
	zrychleni = rand() % init.MAX_ZRYCHLENI + init.MIN_ZRYCHLENI;

	barva = init.pocatecni;
	krokBarvy.r = (init.koncova.r - barva.r) / delka_zivota;
	krokBarvy.g = (init.koncova.g - barva.g) / delka_zivota;
	krokBarvy.b = (init.koncova.b - barva.b) / delka_zivota;
}

///vypocet posunu castice bez prepoctu uhlu
void Castice::posunSe()
{
	if (!jeZiva()) return;

	barva.r += krokBarvy.r;
	barva.g += krokBarvy.g;
	barva.b += krokBarvy.b;

	x += krokX * (rychlost + zrychleni);
	y += krokY * (rychlost + zrychleni);

	if (--zrychleni <= 0)			zrychleni = 0;
	if (--delka_zivota <= 0)	zije = false;
}
