#ifndef PARTICLESYSTEM_H_INCLUDED
#define PARTICLESYSTEM_H_INCLUDED

#include <allegro5/allegro.h>
#include "castice.h"

class ParticleSystemBod
{
protected:
	int uhelDolni, uhelHorni;
	Nastaveni parametry;
	Castice **castice;
	int pocet;
	virtual void opravCastici(int);
	virtual void vytvorCastici(int);
public:
	ParticleSystemBod(int, int, Barva &, Barva &, int = 200, int = 0, int = 360);
	~ParticleSystemBod();
	void nastavMaxZivot(int max)			{ parametry.MAX_ZIVOT = max;			}
	void nastavMinZivot(int min)			{ parametry.MIN_ZIVOT = min;			}
	void nastavMaxRychlost(int max)		{ parametry.MAX_RYCHLOST = max;		}
	void nastavMinRychlost(int min)		{ parametry.MIN_RYCHLOST = min;		}
	void nastavMaxZrychleni(int max)	{ parametry.MAX_ZRYCHLENI = max;	}
	void nastavMinZrychleni(int min)	{ parametry.MIN_ZRYCHLENI = min;	}
	void zmenBarvuStart(Barva &b)			{ parametry.pocatecni = b;	}
	void zmenBarvuKonec(Barva &b)			{ parametry.koncova = b;		}
	void zmenDolniUhel(int uhel)			{ uhelDolni = uhel;	}
	void zmenHorniUhel(int uhel)			{ uhelHorni = uhel;	}
	void zmenPoziciX(int x)						{ parametry.x = x;	}
	void zmenPoziciY(int y)						{ parametry.y = y;	}
	void zmenPocetCastic(int);
	void reset();
	void zobraz();
};

//generovani castic v pasu smerem (-90 nahoru, 0 vpravo, 180 vlevo, 90 dolu)
class ParticleSystemPas : public ParticleSystemBod
{
private:
	int sirka;
protected:
	void opravCastici(int);
	void vytvorCastici(int);
public:
	ParticleSystemPas(int, int, Barva &, Barva &, int = 200, int = 30, int = -90);
	~ParticleSystemPas()							{ }
	void zmenSirkuPasu(int delka)			{ sirka = delka;		}
	void zmenSmer(int);
};

#endif // PARTICLESYSTEM_H_INCLUDED
